#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cstdarg>

const char *IN = "dom.sis";
const char *OUT = "dom.val";

const int MAXN = 9;

void ERR(const char *s, ...) {
    printf("400\nError: ");
    va_list ap;
    va_start(ap, s);
    vprintf(s, ap);
    va_end(ap);
    printf("\n");
    exit(0);
}

void OK(int n, const char *s, ...) {
    printf("200\nScore: %d\nError: ", n);
    va_list ap;
    va_start(ap, s);
    vprintf(s, ap);
    va_end(ap);
    printf("\n");
    exit(0);
}

char *trim(char *s) {
    int i = strlen(s) - 1;
    while (i >= 0 && (s[i] == '\n' || s[i] == '\r' || s[i] == ' '))
        s[i--] = 0;
    return s;
}

char s[50];
int n, k, p;
bool a[MAXN + 1][MAXN + 1];
int i, j1, j2, u;

int main() {
    FILE *in = fopen(IN, "rt");
    if (!in)
        ERR("Viga sisendfaili avamisel");
    if (!fgets(s, sizeof(s), in) ||
            sscanf(trim(s), "%d%d%n", &n, &k, &u) != 2 ||
            u != strlen(s))
        ERR("Viga sisendfaili real 1");
    for (int i = 0; i < k; ++i) {
        if (!fgets(s, sizeof(s), in) ||
                sscanf(trim(s), "%d%d%n", &j1, &j2, &u) != 2 ||
                u != strlen(s) ||
                j1 < 0 || j1 > n || j2 < 0 || j2 > n)
            ERR("Viga sisendfaili real %d", i + 2);
        if (a[j1][j2])
            ERR("Korduv kivi %d:%d sisendfaili real %d", j1, j2, i + 2);
        a[j1][j2] = a[j2][j1] = true;
    }
    if (fscanf(in, "%10s", s) == 1)
        ERR("Liigsed read sisendfaili lpus");
    if (fclose(in))
        ERR("Viga sisendfaili sulgemisel");

    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR("Viga vljundfaili %s avamisel", OUT);
    if (!fgets(s, sizeof(s), out) ||
            sscanf(trim(s), "%d%n", &p, &u) != 1 ||
            u != strlen(s))
        OK(0, "Viga vljundfaili real 1");
    if (k + p != (n + 1) * (n + 2) / 2)
        OK(0, "Vale kivide arv %d", p);
    for (int i = 0; i < p; ++i) {
        if (!fgets(s, sizeof(s), in) ||
                sscanf(trim(s), "%d%d%n", &j1, &j2, &u) != 2 ||
                u != strlen(s) ||
                j1 < 0 || j1 > n || j2 < 0 || j2 > n)
            OK(0, "Viga vljundfaili real %d", i + 2);
        if (a[j1][j2])
            OK(0, "Korduv kivi %d:%d vljundfaili real %d", j1, j2, i + 2);
        a[j1][j2] = a[j2][j1] = true;
    }
    if (fscanf(out, "%10s", s) == 1)
        OK(0, "Liigsed read vljundfaili lpus");
    if (fclose(out))
        ERR("Viga vljundfaili sulgemisel");

    OK(100, "OK");
}
