#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cstdarg>

const char *IN = "pal.sis";
const char *OUT = "pal.val";
const char *HINT = "pal.xxx";

void ERR(const char *s, ...) {
    printf("400\nError: ");
    va_list ap;
    va_start(ap, s);
    vprintf(s, ap);
    va_end(ap);
    printf("\n");
    exit(0);
}

void OK(int n, const char *s, ...) {
    printf("200\nScore: %d\nError: ", n);
    va_list ap;
    va_start(ap, s);
    vprintf(s, ap);
    va_end(ap);
    printf("\n");
    exit(0);
}

char *trim(char *s) {
    int i = strlen(s) - 1;
    while (i >= 0 && (s[i] == '\n' || s[i] == '\r'))
        s[i--] = 0;
    return s;
}

char s1[50];
char s2[50];
int n = 0;
int m = 0;

int main() {
    FILE *hint = fopen(HINT, "rt");
    if (!hint)
        ERR("Viga vihjefaili avamisel");
    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR("Viga vljundfaili %s avamisel", OUT);
    while (fgets(s1, sizeof(s1), hint)) {
        ++n;
        if (!fgets(s2, sizeof(s2), out))
            OK(0, "Enneaegne faili lpp");
        if (strcmp(trim(s1), trim(s2)) == 0)
            ++m;
    }
    if (fscanf(out, "%10s", s2) == 1)
        OK(0, "Liigsed read faili lpus");
    if (fclose(hint))
        ERR("Viga vihjefaili sulgemisel");
    if (fclose(out))
        ERR("Viga vljundfaili sulgemisel");
    if (m < n)
        OK(m * 100 / n, "iged %d rida %d reast", m, n);
    OK(100, "OK");
}
