#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cstdarg>

const char *IN = "ts.sis";
const char *OUT = "ts.val";
const char *HINT = "ts.xxx";

const int MAXN = 1000;

void ERR(const char *s, ...) {
    printf("400\nError: ");
    va_list ap;
    va_start(ap, s);
    vprintf(s, ap);
    va_end(ap);
    printf("\n");
    exit(0);
}

void OK(int n, const char *s, ...) {
    printf("200\nScore: %d\nError: ", n);
    va_list ap;
    va_start(ap, s);
    vprintf(s, ap);
    va_end(ap);
    printf("\n");
    exit(0);
}

char *trim(char *s) {
    int i = strlen(s) - 1;
    while (i >= 0 && (s[i] == '\n' || s[i] == '\r' || s[i] == ' '))
        s[i--] = 0;
    return s;
}

char s[50];
int i, j1, j2, u;

int n, m; // ruutude, tunnelite arv
int a[1+MAXN]; // tunnelid: kui a[i] > 0, on tunnel i-->a[i]
int b[1+MAXN]; // tunnelid: kui b[i] > 0, on tunnel b[i]-->i
int k, kk; // lahendaja, nidislahenduse tringuvisete arv
int p = 1; // nupu jooksev positsioon

int main() {
    FILE *in = fopen(IN, "rt");
    if (!in)
        ERR("Viga sisendfaili avamisel");
    if (!fgets(s, sizeof(s), in) ||
            sscanf(trim(s), "%d%d%n", &n, &m, &u) != 2 ||
            u != strlen(s))
        ERR("Viga sisendfaili real 1");
    for (int i = 0; i < m; ++i) {
        if (!fgets(s, sizeof(s), in) ||
                sscanf(trim(s), "%d%d%n", &j1, &j2, &u) != 2 ||
                u != strlen(s) ||
                j1 < 1 || j1 > n || a[j1] > 0 || b[j1] > 0 ||
                j2 < 1 || j2 > n || a[j2] > 0 || b[j2] > 0)
            ERR("Viga sisendfaili real %d", i + 2);
        a[j1] = j2; b[j2] = j1;
    }
    if (fscanf(in, "%10s", s) == 1)
        ERR("Liigsed read sisendfaili lpus");
    if (fclose(in))
        ERR("Viga sisendfaili sulgemisel");

    FILE *out = fopen(OUT, "rt");
    if (!out)
        ERR("Viga vljundfaili %s avamisel", OUT);
    if (!fgets(s, sizeof(s), out) ||
            sscanf(trim(s), "%d%n", &k, &u) != 1 ||
            u != strlen(s))
        OK(0, "Viga vljundfaili real 1");
    for (int i = 0; i < k; ++i) {
        if (!fgets(s, sizeof(s), in) ||
                sscanf(trim(s), "%d%n", &j1, &u) != 1 ||
                u != strlen(s))
            OK(0, "Viga vljundfaili real %d", i + 2);
        if (j1 < 1 || j1 > 6 || (p += j1) > n)
            OK(0, "Lubamatu kik vljundfaili real %d", i + 2);
        if (a[p] > 0)
            p = a[p];
    }
    if (fscanf(out, "%10s", s) == 1)
        OK(0, "Liigsed read vljundfaili lpus");
    if (p != n)
        OK(0, "Nupp ei peatu lpuruudul");
    if (fclose(out))
        ERR("Viga vljundfaili sulgemisel");

    FILE *hint = fopen(HINT, "rt");
    if (!hint)
        ERR("Viga vihjefaili avamisel");
    if (!fgets(s, sizeof(s), hint) ||
            sscanf(trim(s), "%d%n", &kk, &u) != 1 ||
            u != strlen(s))
        ERR("Viga vihjefaili real 1");
    if (fclose(hint))
        ERR("Viga vihjefaili sulgemisel");

    if (k != kk)
        OK(0, "Vale tringuvisete arv %d, peaks olema %d", k, kk);
    OK(100, "OK");
}
